<?php
/*
 +--------------------------------------------------------------------------+
 | phpMyBackupPro                                                           |
 +--------------------------------------------------------------------------+
 | Copyright (c) 2004 by Dirk Randhahn                                      |
 | http://sourceforge.net/projects/phpmybackup/                             |
 | Version information can be found in definitions.php.                     |
 |                                                                          |
 | This program is free software; you can redistribute it and/or            |
 | modify it under the terms of the GNU General Public License              |
 | as published by the Free Software Foundation; either version 2           |
 | of the License, or (at your option) any later version.                   |
 |                                                                          |
 | This program is distributed in the hope that it will be useful,          |
 | but WITHOUT ANY WARRANTY; without even the implied warranty of           |
 | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the            |
 | GNU General Public License for more details.                             |
 |                                                                          |
 | You should have received a copy of the GNU General Public License        |
 | along with this program; if not, write to the Free Software              |
 | Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,USA.|
 +--------------------------------------------------------------------------+
*/


// standard debug function
function debug($object) {
    echo "<pre>";
    print_r($object);
    echo "</pre>";
}


// prints the basis html header in the $lang language with $scriptname scriptname
function printHeader($scriptname,$lang,$no_login=0) {
    echo "<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01//EN\"
   \"http://www.w3.org/TR/html4/loose.dtd\">
<html>
<head>
<title>phpMyBackupPro ".VERSION."</title>
<meta http-equiv=\"Content-Type\" content=\"text/html; charset=iso-8859-1\">
<link rel=\"stylesheet\" href=\"".STYLE_CSS."\" type=\"text/css\">
";
    readfile(JAVASCRIPTS);
    // define menue
    $menu=array("index.php"=>F_START,"config.php"=>F_CONFIG,"import.php"=>F_IMPORT,"backup.php"=>F_BACKUP,"export_script.php"=>F_SCHEDULE,"db_info.php"=>F_DB_INFO,"sql_query.php"=>F_SQL_QUERY,"HELP"=>"HELP","logout.php"=>F_LOGOUT);
    $simple_width=110;
    $width=count($menu)*$simple_width;
    
    echo "</head>
<body>
<table width=\"".$width."\">
 <colgroup>
  <col span=\"".count($menu)."\" width=\"".$simple_width."\">
 </colgroup>
 <tr>
  <th colspan=\"".count($menu)."\" class=\"active\"><span class=\"pmbp1\">php</span><span class=\"pmbp2\">MyBackup</span><span class=\"pmbp3\">Pro</span><span class=\"pmbp4\"> ".VERSION."</span></th>
 </tr>
 <!-- MENU -->
 <tr>
";

    // generate menu
    foreach($menu as $filename=>$title) {

        // print active link
        if ($filename==$scriptname) {
            echo "  <th  class=\"active\">\n   <a href=\"".$filename."\">".$title."</a>\n  </th>\n";

        // generate popup link for right help file
        } elseif ($title=="HELP")  {
            echo "  <th>\n   ";
            if (!file_exists("./language/".$lang."_help.php")) echo pop_up("./language/english_help.php?script=".$scriptname,F_HELP,"help");
                else echo pop_up("./language/".$lang."_help.php?script=".$scriptname,F_HELP,"help");
            echo "\n  </th>\n";
            
        // print disabled logout link
        } elseif ($filename=="logout.php" && $no_login=="1") {
            echo "  <th>\n   ".$title."\n  </th>\n";

        // print lasting menu
        } else {
            echo "  <th>\n   <a href=\"".$filename."\">".$title."</a>\n  </th>\n";
        }
    }


    echo " </tr>
</table>
<table width=\"".$width."\">
 <colgroup>
  <col width=\"20\">
  <col width=\"*\">
  <col width=\"20\">
 </colgroup>
 <tr>
  <td>
    &nbsp;
  </td>
  <td class=\"main\">
<!-- HEADER END -->
";
}


// print basis html footer
function printFooter() {
    echo "\n<!-- FOOTER -->
  </td>
  <td>
    &nbsp;
  </td>
 </tr>
</table>
<table width=\"990\">
 <tr>
  <th colspan=\"9\" class=\"active\">
   ".F_FOOTER."
  </th>
 </tr>
";
    // check if theres a good internet connection, if it is get the number of the last version
    // do this only once per session
    if (!isset($_SESSION['version'])) @exec("ping -n 1 -w 1000 -l 8 phpmybackup.sourceforge.net",$dontcare,$ping_res);
    if (!isset($_SESSION['version']) && !$ping_res) $last_vers=file("http://phpmybackup.sourceforge.net/vers.php");
    if (!isset($_SESSION['version'])) {
        if (isset($last_vers) && trim($last_vers[0])!=VERSION) $_SESSION['version']=$last_vers[0]; else $_SESSION['version']=FALSE;
    }
    if ($_SESSION['version'])
        echo "\n <tr>
  <td class=\"red\">
    ".F_NOW_AVAILABLE." !!!
  </td>
 </tr>
";

echo "</table>
</body>
</html>
";
}


// prints html export form used on several pages
function printExportForm($host,$uid,$pwd) {
    echo F_SELECT_DB.":<br>
<select name=\"db[]\" multiple=\"multiple\" size=\"10\">
";
    if(!@$con=mysql_connect($host,$uid,$pwd));
    
    // disbale the gzip checkbox if gzopen() is not available
    if (!function_exists('gzopen')) $disable_gzip="disabled"; else $disable_gzip="checked";
    foreach(getDB_List($host,$uid,$pwd) as $db) echo "<option value=\"".$db."\">".$db."</option>\n";
    echo "</select>\n<br>";
    echo set_select("backup","db[]","[".F_SELECT_ALL."]");
    echo "\n<br><br>".F_COMMENTS.":<br>
<textarea name=\"comments\" rows=\"6\" cols=\"60\"></textarea>
<br>
<input type=\"checkbox\" name=\"tables\" checked>".F_EX_TABLES." |
<input type=\"checkbox\" name=\"data\" checked>".F_EX_DATA." |
<input type=\"checkbox\" name=\"drop\" checked>".F_EX_DROP." |
<input type=\"checkbox\" name=\"zip\" ".$disable_gzip.">".F_EX_GZIP
;
}


// generates javascript 'select all in input select' link
function set_select($form,$select,$link){
    return $html="<a href=\"\" onclick=\"setSelect('".$form."','".$select."'); return false;\">".$link."</a>";
}


// generates javascript pop_up link
function pop_up($path, $link, $type){
    return $html="<a href='javascript:popUp(\"".$path."\",\"".$type."\")'>".$link."</a>";
}


// generates javascript confirm dialog
function confirm($text,$path,$link,$conf_type){
    switch ($conf_type) {
        case 0: return "<a href='javascript:confirmClick(\"".$text."\",\"".$path."\")'>".$link."</a>";
        case 1: {
            if (strstr($path,"all") || strstr($path,"ALL")) return "<a href='javascript:confirmClick(\"".$text."\",\"".$path."\")'>".$link."</a>";
                else return "<a href=\"".$path."\">".$link."</a>";
        }
        case 2: {
            if (strstr($path,"ALL")) return "<a href='javascript:confirmClick(\"".$text."\",\"".$path."\")'>".$link."</a>";
                else return "<a href=\"".$path."\">".$link."</a>";
        }
        case 3: return "<a href=\"".$path."\">".$link."</a>";
    }
}


// generated a dump of $db database from $host host using $user username and $passwd password.
// $tables and $data set whether tables or data to backup
function dump($host,$user,$passwd,$db,$tables,$data,$drop,$zip) {

    // set max string size before writing to file
    $max_size=1048576; // 1MB
    
    // set backupfile name
    if ($zip) $backupfile=$db.".".time().".sql.gz"; else $backupfile=$db.".".time().".sql";
                    
    if ($con=@mysql_connect($host,$user,$passwd)) {

        //create comment
        $out="# mySQL DB dump of database '".$db."'\n";
        $out.="# build by phpMyBackupPro ".VERSION."\n";
        $out.="# http://sourceforge.net/projects/phpmybackup/\n\n\n";
        $out.="use ".$db.";";

        // get create table and insert data sql queries for each table
        $res=mysql_list_tables($db);
        for ($i=0;$i<mysql_num_rows($res);$i++) {
            $row=mysql_fetch_row($res);
            $tablename=$row[0];

            // export tables
            if ($tables) {
                $res1=mysql_query('SHOW CREATE TABLE ' . $db. '.' . $tablename);
                $table_sql=mysql_fetch_array($res1);

                $out.="\n\n\n";
                if ($drop) $out.="DROP TABLE IF EXISTS `".$tablename."`;\n";
                $out.=$table_sql[1];
                $out.=";\n\n";
            }
        
            // export data
            if ($data) {
                $res2=mysql_query("select * from `".$tablename."`");
                for ($j=0;$j<mysql_num_rows($res2);$j++){
                    $out .= "insert into `".$tablename."` values (";
                    $row=mysql_fetch_row($res2);
                    for ($k=0;$k<$nf=mysql_num_fields($res2);$k++) {
                        $out .="'".mysql_escape_string($row[$k])."'";
                        if ($k<($nf-1)) $out .=", ";
                    }
                $out .=");\n";
                if (strlen($out)>$max_size) $out=save_to_file($backupfile,$zip,$out);
                }
            }
            if (strlen($out)>$max_size) $out=save_to_file($backupfile,$zip,$out);
        }
        if (mysql_error()) return 0;
        @mysql_close($con);
        save_to_file($backupfile,$zip,$out);
        return $backupfile;
    } else {
        return 0;
    }
}


// saves the string in $fileData to the file $backupfile as gz file or not ($zip)
function save_to_file($backupfile,$zip,$fileData) {
    if ($zip) {
        $zp=gzopen("./".EXPORT_DIR.$backupfile,"a9");
        gzwrite($zp,$fileData);
        gzclose($zp);
    } else {
        $fp=fopen("./".EXPORT_DIR.$backupfile,"a");
        fwrite($fp,$fileData);
        fclose($fp);
    }
    return "";
}


// saves $files backup files on $server ftp server in $path path using $user username and $pass password
function ftp_store($files,$server,$user,$passwd,$path,$pasv,$port=21) {

    // try to connect to server using username and passwort
    if (!$conn_id=@ftp_connect($server,$port)) {
        $out.=F_FTP_1." '".$server."'!";
    } else {
        if (!$login_result=@ftp_login($conn_id,$user,$passwd)) {
            $out .= F_FTP_2." '".$user."'.";
        } else {

            // succesfully connected
            if ($pasv) ftp_pasv($conn_id, 'TRUE'); else ftp_pasv($conn_id,'FALSE');

           // upload all files
            foreach($files as $filename) {
                if (!$path) $path=".";
                $dest_file=$path."/".$filename;
                $source_file="./".EXPORT_DIR.$filename;
                
                // try three times to upload if upload failes
                $check=FALSE;
                for($i=0;$i<3;$i++) if (!$check) $check=@ftp_put($conn_id,$dest_file,$source_file,FTP_BINARY);

                if (!$check) $out .= F_FTP_3.": '".$source_file."' -> '".$dest_file."'.<br>\n"; else $out .= F_FTP_4." '".$dest_file."'.<br>\n";
            }
    
            // close the FTP connection
            if (@function_exists("ftp_close")) @ftp_close($conn_id);
        }
    }
    return $out;
}


// send email with $attachments backup files to $email email using $sitename for sender and subject
function email_store($attachments,$email,$sitename,$backup_info) {

    // verify email
    if (!eregi("^[a-zA-Z0-9_-]+(\.[a-zA-Z0-9\._-]+)*@([a-zA-Z0-9-]+\.)+([a-z]{2,4})$", $email)) $out=F_MAIL_1."<br>\r\n";

    // create header
    $boundary=md5 (uniqid (rand()));
    $headers="From: phpMyBackupPro on ".$sitename." <".$email.">\r\n";
    $headers.="MIME-Version: 1.0\r\n";
    $headers.="Content-Type: multipart/mixed;";
    $headers.=" boundary=".$boundary."\r\n";

    $boundary="\r\n--".$boundary."\r\n";

    // begin mail
    $Msg="This is a multi-part message in MIME format.\r\n";
    $Msg.=$boundary;

    // plaintext part
    $Msg.="Content-Type: text/plain; charset=\"iso-8859-15\"\r\n";
    $Msg.="Content-Transfer-Encoding: 8bit\r\n\r\n";

    $Msg.=F_MAIL_2." '".$sitename."'.\r\n";
    $trans=array_flip(get_html_translation_table(HTML_ENTITIES));
    $str_yes=strtr(F_YES, $trans);
    $str_no=strtr(F_NO, $trans);
    if ($backup_info['gzip']) $Msg.=strtr(INF_GZIP, $trans).": ".$str_yes."\r\n"; else $Msg.=strtr(INF_GZIP, $trans).": ".$str_no."\r\n";
    if ($backup_info['drop']) $Msg.=strtr(INF_DROP, $trans).": ".$str_yes."\r\n"; else $Msg.=strtr(INF_DROP, $trans).": ".$str_no."\r\n";
    if ($backup_info['tables']) $Msg.=strtr(INF_TABLES, $trans).": ".$str_yes."\r\n"; else $Msg.=strtr(INF_TABLES, $trans).": ".$str_no."\r\n";
    if ($backup_info['data']) $Msg.=strtr(INF_DATA, $trans).": ".$str_yes."\r\n"; else $Msg.=strtr(INF_DATA, $trans).": ".$str_no."\r\n";
    $Msg.=INF_COMMENT.":\r\n".$backup_info['comments'];

    // attachments
    foreach($attachments as $fileName) {
    $Msg2=$boundary;
        $Msg2.="Content-Type: application/octetstream; name=\"".$fileName."\"\r\n";
        $Msg2.="Content-Transfer-Encoding: base64\r\n";
        $Msg2.="Content-Disposition: attachment; filename=\"".$fileName."\"\r\n\r\n";

        //file goes here
        $fileName=EXPORT_DIR.$fileName;
        if (!$fd=@fopen ($fileName, "r")) {
            $out.=$fileName." ".F_MAIL_3."\r\n";
        } else {
            $fileContent=@fread($fd,filesize($fileName));
            @fclose ($fd);
            $fileContent=chunk_split(base64_encode($fileContent));
            $Msg2.=$fileContent;
            $Msg.=$Msg2;
        }
    }

    // send mail
    if (!mail("<".$email.">",strtr(F_MAIL_4." ".$sitename, $trans),$Msg,$headers)) return $out.F_MAIL_5.".<br>\n";
        else return $out.F_MAIL_6." ".$email.".";
}


// returns actual local backup files after deleting backups files older then $deltime days
function get_backup_files($del_time) {
        $all_files=FALSE;
        $handle=opendir("./".EXPORT_DIR);
        $remove_time=time()-($del_time*86400);
        while ($file=readdir($handle)) {
            if ($file!="." && $file!=".." && preg_match("'\.sql$|\.sql.gz'",$file)) {
            
                // don't remove if $del_time is false
                if (file_info("time",$file)<$remove_time && $del_time) {
                    @unlink("./".EXPORT_DIR.$file);
                    comment("delete",$file);
                } else {
                    $all_files[]=$file;
                }
            }
        }
    return $all_files;
}


// returns list of databases on $host host using $user user and $passwd password
function getDB_List($host,$user,$passwd) {
    $con=mysql_connect($host,$user,$passwd);
    $db_list=mysql_list_dbs();
    while ($row=mysql_fetch_object($db_list))
        if (mysql_select_db($row->Database)) $list[]=$row->Database;
    return $list;
}


// in dependency on $mode different modes can be selected (see below)
function comment($mode,$filename,$comment="") {
    switch($mode) {

        // to $filename backup file the $comment comment is writen in the comments file
        case "set":
            $fp=fopen("./".EXPORT_DIR.COMMENTS_DAT, "a");
            fwrite($fp,$filename."::".preg_replace("'\r\n'"," ",$comment)."\n");
            fclose($fp);
        break;

        // the comment to $filename backup file in the comments file will be deleted
        case "delete":
            $rows=file("./".EXPORT_DIR.COMMENTS_DAT);
            $fp=fopen("./".EXPORT_DIR.COMMENTS_DAT, "w");
            foreach($rows as $row) if (!preg_match("'^".$filename."::'",$row)) fwrite($fp,$row);
            fclose($fp);
        break;
        
        // return the comment to $filename backup file from the comments file
        case "get":
            $rows=@file("./".EXPORT_DIR.COMMENTS_DAT);
            if (is_array($rows))
                foreach($rows as $row) if (preg_match("'^".$filename."::'",$row)) return preg_replace("'^".$filename."::'","",$row);
        break;
    }
}


// in dependency on $mode different modes can be selected (see below)
function file_info($mode,$path) {
    #if (preg_match("'/'",$path))
    $filename=ereg_replace(".*/","",$path);
    #else $filename=$path;
    $parts=explode(".",$filename);
    switch($mode) {
    
        // returns the name of the database a $path backup file belongs to
        case "db":
            return $parts[0];
        break;

        // returns the creation timestamp $path backup file
        case "time":
            return $parts[1];
        break;
        
        // returns ".gz" if $path backup file is gziped
        case "gzip":
            return $parts[3];
        break;

        // returns the size of $path backup file
        case "size":
            return filesize($path);
        break;

        // returns yes if the backup file contains 'drop table if exists' or no if not
        case "drop":
            if (file_info("gzip",$path)) $lines=ungzip("lines",$path); else $lines=file($path);
            foreach($lines as $line){
                $line=trim($line);
                if (strtolower(substr($line,0,20))=="drop table if exists") return F_YES; else $drop=F_NO;
            }
            return $drop;

        break;
        
        // returns yes if the $path backup files contains tables or no if not
        case "tables":
            if (file_info("gzip",$path)) $lines=ungzip("lines",$path); else $lines=file($path);
            foreach($lines as $line){
                $line=trim($line);
                if (strtolower(substr($line,0,6))=="create") return F_YES; else $table=F_NO;
            }
            return $table;
        break;

        // returns yes if the $path backup files contains data or no if not
        case "data":
            if (file_info("gzip",$path)) $lines=ungzip("lines",$path); else $lines=file($path);
            foreach($lines as $line){
                $line=trim($line);
                if (strtolower(substr($line,0,6))=="insert") return F_YES; else $data=F_NO;
            }
            return $data;
        break;
    }
}


// returns the content of the gziped $path backup file. use of $mode see below
function ungzip($mode,$path) {
                 $file_data=gzfile ($path);
                // return is one string or an array of lines
                if ($mode!="lines") return implode("",$file_data); else return $file_data;
}


// determines the best size type for filesize $size and returns array('value'=xxx,'type'=yyy)
function size_type($size) {
    $types=array("B","KB","MB","GB");
    for ($i=0; $size>1000; $i++,$size/=1024);
    $result['value']=round($size,2);
    $result['type']=$types[$i];
    return $result;
}


// get recursive directory list
function get_dirs($wdir) {
    $dirs=FALSE;
    $dir_handle=@opendir($wdir);
    while ($file=@readdir ($dir_handle)) {
        if ($file!="." && $file!="..") {
            if (is_dir($wdir.$file)) {
                $dirs[]=$file."/";
                $tmp=get_dirs($wdir.$file."/");
                if (is_array($tmp))
                foreach($tmp as $value) $dirs[]=$file."/".$value;
            }
        }
    }
    return $dirs;
}
?>
